leetcode 975. Odd Even Jump

给定一个整数数组,从某个起始索引开始,你可以进行一系列跳跃。奇数次跳跃向前跳到较小的索引,偶数次跳跃向前跳到较大的索引。找到能到达数组末尾的起始索引数量。
摘要由CSDN通过智能技术生成

You are given an integer array A.  From some starting index, you can make a series of jumps.  The (1st, 3rd, 5th, ...) jumps in the series are called odd numbered jumps, and the (2nd, 4th, 6th, ...) jumps in the series are called even numbered jumps.

You may from index i jump forward to index j (with i < j) in the following way:

  • During odd numbered jumps (ie. jumps 1, 3, 5, ...), you jump to the index j such that A[i] <= A[j] and A[j] is the smallest possible value.  If there are multiple such indexes j, you can only jump to the smallest such index j.
  • During even numbered jumps (ie. jumps 2, 4, 6, ...), you jump to the index j such that A[i] >= A[j] and A[j] is the largest possible value.  If there are multiple such indexes j, you can only jump to the smallest such index j.
  • (It may be the case that for some index i,there are no legal jumps.)

A starting index is good if, starting from that index, you can reach the end of the array (index A.length - 1) by jumping some number of times (possibly 0 or more than once.)

Return the number of good starting indexes.

 

Example 1:

Input: [10,13,12,14,15]
Output: 2
Explanation: 
From starting index i = 0, we can jump to i = 2 (since A[2] is the smallest among A[1], A[2], A[3], A[4] that is greater or equal to A[0]), then we can't jump any more.
From starting index i = 1 and i = 2, we can jump to i = 3, then we can't jump any more.
From starting index i = 3, we can jump to i = 4, so we've reached the end.
From starting index i = 4, we've reached the end already.
In total, there are 2 different starting indexes (i = 3, i = 4) where we can reach the end with some number of jumps.

Example 2:

Input: [2,3,1,1,4]
Output: 3
Explanation: 
From starting index i = 0, we make jumps to i = 1, i = 2, i = 3:

During our 1st jump (odd numbered), we first jump to i = 1 because A[1] is the smallest value in (A[1], A[2], A[3], A[4]) that is greater than or equal to A[0].

During our 2nd jump (even numbered), we jump from i = 1 to i = 2 because A[2] is the largest value in (A[2], A[3], A[4]) that is less than or equal to A[1].  A[3] is also the largest value, but 2 is a smaller index, so we can only jump to i = 2 and not i = 3.

During our 3rd jump (odd numbered), we jump from i = 2 to i = 3 because A[3] is the smallest value in (A[3], A[4]) that is greater than or equal to A[2].

We can't jump from i = 3 to i = 4, so the starting index i = 0 is not good.

In a similar manner, we can deduce that:
From starting index i = 1, we jump to i = 4, so we reach the end.
From starting index i = 2, we jump to i = 3, and then we can't jump anymore.
From starting index i = 3, we jump to i = 4, so we reach the end.
From starting index i = 4, we are already at the end.
In total, there are 3 different starting indexes (i = 1, i = 3, i = 4) where we can reach the end with some number of jumps.

Example 3:

Input: [5,1,3,4,2]
Output: 3
Explanation: 
We can reach the end from starting indexes 1, 2, and 4.

 

Note:

  1. 1 <= A.length <= 20000
  2. 0 <= A[i] < 100000

解题思路:

class Solution {
public:
    int oddEvenJumps(vector<int>& A) 
    {
        if(A.empty()) return 0 ;
        
        map<int , list<int>> nums ;
        int n = A.size() , res = 0 ;
        vector<vector<int>> dp(n , vector<int>(2 , 0)) ;
        dp[n - 1][0] = 1 ; 
        dp[n - 1][1] = 1 ;
        nums[A[n - 1]].push_front(n - 1) ;
        
        for(int i = n - 2 ; i >= 0 ; --i)
        {
            auto it = nums.lower_bound(A[i]) ;
            if(it != nums.end())
            {
                int jx = it->second.front() ;
                if(dp[jx][1]) dp[i][0] = 1 ;
                
                if(it->first == A[i])
                {
                    if(dp[it->second.front()][0]) dp[i][1] = 1 ;
                }
                else
                {
                    if(it != nums.begin())
                    {
                        auto p = prev(it , 1) ;
                        if(dp[p->second.front()][0]) dp[i][1] = 1 ;
                    }
                }
            }
            else
            {
                auto p = prev(it , 1) ;
                if(dp[p->second.front()][0]) dp[i][1] = 1 ;
            }
            
            nums[A[i]].push_front(i) ;
        }
        
        for(int i = 0 ; i < n ; ++i)
        {
            if(dp[i][0]) res++ ;
        }
        
        return res ;
    }
};

 

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值